<?

/*  FUNES DA IMPRESSORA  */

global $impressora;
global $comandos;
global $saida;

// Define a saida dos comandos
// 0: fwrite / 1: variavel
$saida	= 0;

// Inicializa a impressora
function iniciar()
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if($saida==0)
			{
				$impressora	= fopen ("LPT1", "wb");
				fwrite($impressora, chr(27).chr(64).chr(17).chr(13).chr(7));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				$comandos[]	= "64";
				$comandos[]	= "17";
				$comandos[]	= "13";
				$comandos[]	= "7";
			}
		condensado(1);
	}
	

// Modo condesado
// 1: liga / 0: desliga
function condensado($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if($saida==0)
			{
				if($x!=0)
					{
						fwrite($impressora, chr(15).chr(13));
					}
				else
					{
						fwrite($impressora, chr(18).chr(13));
					}
			}
		else
			{
				if($x!=0)
					{
						$comandos[]	= "15";
						$comandos[]	= "13";
					}
				else
					{
						$comandos[]	= "18";
						$comandos[]	= "13";
					}
			}
	}

// Finaliza a impressora
function finalizar()
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if($saida==0)
			{
				fwrite($impressora, chr(10).chr(13));
				fwrite($impressora, chr(12).chr(19));
				fclose($impressora);
			}
		if($saida==1)
			{
				$comandos[]	= "10";
				$comandos[]	= "13";
				$comandos[]	= "12";
				$comandos[]	= "19";
			}
	}


// Grava o espaco entre linha padrao 
function espaco_entre_linha($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if(intval($x)==0)
			$x=30;
		
		if($saida==0)
			{
				fwrite($impressora, chr(27).chr(51).chr($x));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				$comandos[]	= "51";
				$comandos[]	= $x;
			}
	}


// Grava a coluna padrao 
function coluna($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if(intval($x)==0)
			$x=1;
			
		if($saida==0)
			{
				fwrite($impressora, chr(13).chr(27).chr(108).chr($x));
			}
		if($saida==1)
			{
				$comandos[]	= "13";
				$comandos[]	= "27";
				$comandos[]	= "108";
				$comandos[]	= $x;			
			}		
	}


// Pula uma linha seguindo o espaco entre linha padrao
function pula_linha($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if(intval($x)==0)
			$x=1;
			
		if($saida==0)
			{
				$y=1;
				while($y<=$x)
					{
						fwrite($impressora, chr(10));
						fwrite($impressora, chr(13));
						$y++;
					}
			}
		if($saida==1)
			{
				$y=1;
				while($y<=$x)
					{
						$comandos[]	= "10";
						$comandos[]	= "13";	
						$y++;
					}	
			}	
	}



// Seleciona o modo da fonte
// 0: rascunho / 1: qualidade carta
function fonte_modo($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if(intval($x)!=1)
			$x=0;
				
		if($saida==0)
			{
				fwrite($impressora, chr(27).chr(120).chr($x));
				fwrite($impressora, chr(13));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				$comandos[]	= "120";
				$comandos[]	= $x;		
			}		
	}



// Seleciona a familia da fonte
// 0: Roman / 1: Sans Serif
function fonte_familia($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if(intval($x)!=1)
			$x=0;
				
		if($saida==0)
			{
				fwrite($impressora, chr(27).chr(107).chr($x));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				$comandos[]	= "127";
				$comandos[]	= $x;		
			}	
		
	}



// Seleciona o tamanho da fonte
// 0: 10cpp / 1: 12cpp
function fonte_tamanho($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
		
		if($saida==0)
			{
				if(intval($x)!=1)
					fwrite($impressora, chr(27).chr(80));
				else
					fwrite($impressora, chr(27).chr(77));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				if(intval($x)!=1)
					$comandos[]	= "80";
				else
					$comandos[]	= "77";
			}
	}



// Seleciona a familia da fonte
// 0: pitch 10 / 1: pitch 12 / 2: proporcional / 4: condesado
// 8: enfatizado / 16: batida dupla / 32: largura dupla
// 64: italico / 128: sublinhado
function fonte_estilo($x)
	{
		global $impressora;
		global $comandos;
		global $saida;
				
		if(!(intval($x)>1))
			$x=0;
		
		if($saida==0)
			{
				fwrite($impressora, chr(27).chr(33).chr($x));
			}
		if($saida==1)
			{
				$comandos[]	= "27";
				$comandos[]	= "33";
				$comandos[]	= $x;
			}		
	}



// Imprime o texto	
function imprimir($texto)
	{	
		global $impressora;
		global $comandos;
		global $saida;
		
		// Inicializa area de texto	
		if($saida==0)
			{
				fwrite($impressora, chr(02));
			}
		if($saida==1)
			{
				$comandos[]	= "02";
			}		
		
		// Gera a tabela ascii
		$x	= 0;		
		while($x<=255)
			{
				$ascii[$x]	= 	chr($x);			
				$x++;
			}
		
		// Verifica caracter por caracter no seu correspondente na tabela
		$x	= 0;
		$y	= strlen($texto);
		while($x<$y)
			{
				$z=0;
				while($z<=255)
					{
						if($ascii[$z]==$texto[$x])
							{
								// Imprimi o caracter								
								if($saida==0)
									{
										fwrite($impressora, chr($z));
									}
								if($saida==1)
									{
										$comandos[]	= $z;
									}	
								$z=256;
							}
						$z++;
					}
				$x++;
			}		
		
		// Finaliza area de texto									
		if($saida==0)
			{
				fwrite($impressora, chr(03));
			}
		if($saida==1)
			{
				$comandos[]	= "03";
			}			
	}
	













/*  VARIAVEIS  */

$numeroNotaFiscal = "";

// 1 linha
$natureza	= "";
$cfop		= "";
$inscEstTri	= "";


// DESTINATARIO

// 1 linha
$destNome	= "";
$destCPF	= "";
$dataEmissao= "";
// 2 linha
$destEnd	= "";
$destBairro	= "";
$destCep	= "";
$dataSaida	= "";
// 3 linha
$destMunic	= "";
$destFone	= "";
$destEst	= "";
$destInscEst= "";
$horaSaida	= "";


// FATURA

// 1 linha
$fatAVenc	= "";
$fatAVal	= "";
$fatBVenc	= "";
$fatBVal	= "";
$fatCVenc	= "";
$fatCVal	= "";
// 2 linha
$fatDVenc	= "";
$fatDVal	= "";
$fatEVenc	= "";
$fatEVal	= "";
$fatFVenc	= "";
$fatFVal	= "";
// 3 linha
$fatPraca	= "";


// PRODUTOS

$prodCod[]	= "";
$prodDesc[]	= "";
$prodFisc[]	= "";
$prodTrib[]	= "";
$prodUnid[]	= "";
$prodQnt[]	= "";
$prodVU[]	= "";
$prodVT[]	= "";
$prodICMS[]	= "";
$prodIPI[]	= "";
$prodVIPI[]	= "";


// CLCULO DO IMPOSTO

// 1 linha
$impBICMS	= "";
$impVICMS	= "";
$impBICMSS	= "";
$impVBCMSS	= "";
$impVTP		= "";
// 2 linha
$impFrete	= "";
$impSeguro	= "";
$impODA		= "";
$impVTIPI	= "";
$impVTNota	= "";


// TRANSPORTADOR / VOLUMES TRANSPORTADOS

// 1 linha
$transNome	= "";
$transFrete	= "";
$transPlaca	= "";
$transPEst	= "";
$transCNPJ	= "";
// 2 linha
$transEnd	= "";
$transMunic	= "";
$transEst	= "";
$transInscE	= "";
// 3 linha
$transQNT	= "";
$transEspec	= "";
$transMarca	= "";
$transNum	= "";
$transPesoB	= "";
$transPesoL	= "";


// DADOS ADICIONAIS

$dadAdic	= "";
$dadFisco	= "";
















/*  COMANDOS  */
iniciar();

// Numero da nota fiscal
condensado(1);
coluna(126);
imprimir($numeroNotaFiscal);
coluna(0);

// Marca o X na saida
espaco_entre_linha(10);
pula_linha(1);
condensado(0);
coluna(53);
imprimir("X");
coluna(0);
condensado(1);

espaco_entre_linha(30);
pula_linha(9);
espaco_entre_linha(5);
pula_linha(5);
espaco_entre_linha(30);
 
// Natureza
imprimir($natureza);
coluna(0);

// Cfop
coluna(40);
imprimir($cfop);
coluna(0);

// inscricao estadual 
coluna(47);
imprimir($inscEstTri);
coluna(0);

pula_linha(3);
espaco_entre_linha(10);
pula_linha(3);
espaco_entre_linha(30);







// nome
imprimir($destNome);
coluna(0);

// cpf
coluna(84);
imprimir($destCPF);
coluna(0);

// data emissao
coluna(122);
imprimir($dataEmissao);
coluna(0);

pula_linha(2);
espaco_entre_linha(10);
pula_linha(1);
espaco_entre_linha(30);





// endereco
imprimir($destEnd);
coluna(0);

// bairro
coluna(64);
imprimir($destBairro);
coluna(0);

// cep
coluna(95);
imprimir($destCep);
coluna(0);

// data saida / entrada
coluna(122);
imprimir($dataSaida);
coluna(0);

pula_linha(2);
espaco_entre_linha(5);
pula_linha(2);
espaco_entre_linha(30);




// municipio
imprimir($destMunic);
coluna(0);

// fone fax
coluna(47);
imprimir($destFone);
coluna(0);

// uf
coluna(78);
imprimir($destEst);
coluna(0);

// inscricao estadual
coluna(84);
imprimir($destInscEst);
coluna(0);

// hora saida
coluna(125);
imprimir($horaSaida);
coluna(0);







pula_linha(3);
espaco_entre_linha(5);
pula_linha(3);
espaco_entre_linha(30);


// 1 duplicata vencimento
coluna(30);
imprimir($fatAVenc);
coluna(0);

// 1 duplicata valor
coluna(45);
imprimir($fatAVal);
coluna(0);

// 2 duplicata vencimento
coluna(68);
imprimir($fatBVenc);
coluna(0);

// 2 duplicata valor
coluna(83);
imprimir($fatBVal);
coluna(0);

// 3 duplicata vencimento
coluna(106);
imprimir($fatCVenc);
coluna(0);

// 3 duplicata valor
coluna(121);
imprimir($fatCVal);
coluna(0);


pula_linha(1);


// 4 duplicata vencimento
coluna(30);
imprimir($fatDVenc);
coluna(0);

// 4 duplicata valor
coluna(45);
imprimir($fatDVal);
coluna(0);

// 5 duplicata vencimento
coluna(68);
imprimir($fatEVenc);
coluna(0);

// 5 duplicata valor
coluna(83);
imprimir($fatEVal);
coluna(0);

// 6 duplicata vencimento
coluna(106);
imprimir($fatFVenc);
coluna(0);

// 6 duplicata valor
coluna(121);
imprimir($fatFVal);
coluna(0);


espaco_entre_linha(5);
pula_linha(18);


// Praca de pagamento
imprimir($fatPraca);
coluna(0);


espaco_entre_linha(5);
pula_linha(20);
espaco_entre_linha(40);




// produtos


$x		= 0;
$total	= count($prodCod);
while($x<$total)
	{
// codigo produto
coluna(0);
imprimir($prodCod[$x]);
coluna(0);

// descricao dos produtos
coluna(15);
imprimir($prodDesc[$x]);
coluna(0);

// calculo fiscal
coluna(59);
imprimir($prodFisc[$x]);
coluna(0);

// sit trib
coluna(64);
imprimir($prodTrib[$x]);
coluna(0);

// unid
coluna(69);
imprimir($prodUnid[$x]);
coluna(0);

// quant
coluna(80);
imprimir($prodQnt[$x]);
coluna(0);

// valor unitario
coluna(93);
imprimir($prodVU[$x]);
coluna(0);

// valor total
coluna(107);
imprimir($prodVT[$x]);
coluna(0);

// aliquota icms
coluna(116);
imprimir($prodICMS[$x]);
coluna(0);

// aliquota ipi
coluna(121);
imprimir($prodIPI[$x]);
coluna(0);

// valor ipi
coluna(131);
imprimir($prodVIPI[$x]);
coluna(0);

		$x++
	}



pula_linha(18);


// base de calculo do icms
coluna(16);
imprimir($impBICMS);
coluna(0);

// valor do icms
coluna(38);
imprimir($impVICMS);
coluna(0);

// base calculo icms substituicao
coluna(70);
imprimir($impBICMSS);
coluna(0);

// valor icms substituicao
coluna(100);
imprimir($impVBCMSS);
coluna(0);

// valor total dos produtos
coluna(130);
imprimir($impVTP);
coluna(0);


pula_linha(2);


// valor frete
coluna(16);
imprimir($impFrete);
coluna(0);

// valor do seguro
coluna(38);
imprimir($impSeguro);
coluna(0);

// outras despesas acessorias
coluna(70);
imprimir($impODA);
coluna(0);

// valor total do ipi
coluna(100);
imprimir($impVTIPI);
coluna(0);

// valor total da nota
coluna(130);
imprimir($impVTNota);
coluna(130);
imprimir($impVTNota);
coluna(0);



pula_linha(2);
espaco_entre_linha(5);
pula_linha(3);
espaco_entre_linha(35);



// nome razao social
coluna(0);
imprimir($transNome);
coluna(0);

// frete por conta
coluna(77);
imprimir($transFrete);
coluna(0);

// placa veiculo
coluna(90);
imprimir($transPlaca);
coluna(0);

// uf
coluna(102);
imprimir($transPEst);
coluna(0);

// cnpj cpf
coluna(107);
imprimir($transCNPJ);
coluna(0);



pula_linha(2);



// endereco
coluna(0);
imprimir($transEnd);
coluna(0);

// municipio
coluna(60);
imprimir($transMunic);
coluna(0);

// uf
coluna(102);
imprimir($transEst);
coluna(0);

// inscricao estadual
coluna(107);
imprimir($transInscE);
coluna(0);



pula_linha(2);



// quantidade
coluna(0);
imprimir($transQNT);
coluna(0);

// especie
coluna(15);
imprimir($transEspec);
coluna(0);

// marca
coluna(60);
imprimir($transMarca);
coluna(0);

// numero
coluna(75);
imprimir($transNum);
coluna(0);

// peso bruto
coluna(89);
imprimir($transPesoB);
coluna(0);

// peso liquido
coluna(113);
imprimir($transPesoL);
coluna(0);



pula_linha(2);



// dados adicionais
coluna(0);
imprimir($dadAdic);
coluna(0);

// reservado ao fisco
coluna(75);
imprimir($dadFisco);
coluna(0);



//imprimir("12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567");


finalizar();




if($saida==0)
	{
		echo "impresso direto";
	}
if($saida==1)
	{
		echo "impresso aparte<br>".chr(13);
		echo "total de ".count($comandos)." comandos<br>".chr(13);
		$comandos	= implode(",".chr(13),$comandos);
		echo $comandos;
	}
?>